searchNodes=[{"doc":"A module that contains a function to test the dispatch of forms. This will make it easier to write integration tests to check if forms in Phoenix templates will submit to the intended controller action with the right params.","ref":"TestDispatch.html","title":"TestDispatch","type":"module"},{"doc":"Finds a link by a given conn, test_selector and an optional test_value. Hereby it tries to get a response from the conn and find the first &lt;a&gt;&lt;/a&gt; element that has the combination of the test_selector and test_value. The link that is found will be dispatched with Phoenix.ConnTest.dispatch/4 . The method will be derived from the link by the data-method attribute and has &quot;get&quot; as default. The path will be taken from the href . Examples With the given page on &quot;/posts/1&quot; &lt;html&gt; &lt;body&gt; &lt;h1&gt;Post&lt;/h1&gt; &lt;a href=&quot;/posts/1&quot; data-method=&quot;delete&quot; test-selector=&quot;post-123-delete-post&quot;&gt; Remove &lt;/a&gt; &lt;table&gt; &lt;th&gt;Comment&lt;/td&gt; &lt;th&gt;Upvote&lt;/td&gt; &lt;tr&gt; &lt;td&gt;This is perfect&lt;/td&gt; &lt;td&gt; &lt;a href=&quot;/posts/1/comments/1&quot; data-method=&quot;post&quot; test-value=&quot;1&quot; test-selector=&quot;post-123-upvote-comment&quot; &gt; Upvote Comment &lt;/td&gt; &lt;/tr&gt; &lt;/table&gt; &lt;/body&gt; &lt;/html&gt; iex&gt; conn = build_conn() |&gt; get(&quot;/posts/1&quot;) iex&gt; result = click_link(conn, &quot;post-123-delete-post&quot;) iex&gt; with %Plug.Conn{request_path: &quot;/posts/1&quot;, method: &quot;DELETE&quot;} &lt;- result, do: :ok :ok iex&gt; conn = build_conn() |&gt; get(&quot;/posts/1&quot;) iex&gt; result = click_link(conn, &quot;post-123-upvote-comment&quot;, &quot;1&quot;) iex&gt; with %Plug.Conn{request_path: &quot;/posts/1/comments/1&quot;, method: &quot;POST&quot;} &lt;- result, do: :ok :ok","ref":"TestDispatch.html#click_link/4","title":"TestDispatch.click_link/4","type":"function"},{"doc":"See submit_form/3 for documentation.","ref":"TestDispatch.html#dispatch_form/3","title":"TestDispatch.dispatch_form/3","type":"function"},{"doc":"See submit_form/3 for documentation.","ref":"TestDispatch.html#dispatch_form/4","title":"TestDispatch.dispatch_form/4","type":"function"},{"doc":"See click_link/4 for documentation.","ref":"TestDispatch.html#dispatch_link/4","title":"TestDispatch.dispatch_link/4","type":"function"},{"doc":"Will take a conn that was redirected. It takes the path that was redirected to and performs a get on it. If the status does not match the redirected status it will raise an error. By default the status is 302. Examples iex&gt; conn = build_conn ( ) |&gt; get ( &quot;/posts/1&quot; ) iex&gt; conn = click_link ( conn , &quot;post-123-delete-post&quot; ) iex&gt; result = follow_redirect ( conn , 302 ) |&gt; html_response ( 200 ) iex&gt; if result =~ &quot;Posts Index&quot; , do : :ok :ok","ref":"TestDispatch.html#follow_redirect/2","title":"TestDispatch.follow_redirect/2","type":"function"},{"doc":"Checks for an incomming mail and puts it on the conn as the resp_html. It returns the conn on which the click_link/3 can be called. Params :subject Match the received mail to the subject :to Match the received mail to the receiver of the mail :from Match the received mail to the sender of the mail Examples iex&gt; conn = build_conn ( ) |&gt; get ( &quot;/posts/1&quot; ) |&gt; click_link ( &quot;post-123-send-as-mail&quot; ) iex&gt; conn = receive_mail ( conn , %{ subject : &quot;Post 1&quot; } ) iex&gt; result = click_link ( conn , &quot;post-123-show&quot; ) |&gt; html_response ( 200 ) iex&gt; if result =~ &quot;Posts 123&quot; , do : :ok","ref":"TestDispatch.html#receive_mail/2","title":"TestDispatch.receive_mail/2","type":"function"},{"doc":"Will find a form in the HTML response of the given conn by entity or by TestSelector , or, if no entity or test_selector is provided, it will target the last form found in the response. Next it will look for form controls (inputs, selects), convert these to params and use the attributes passed to submit_form/3 to update the values of the params. The params will now only contain field keys found in the controls of the form. If an entity is given, the params will be prepended by this entity. Ultimately, the conn is dispatched to the conn's private.phoenix_endpoint using Phoenix.ConnTest.dispatch/5 , with the params and with the method and action found in the form.","ref":"TestDispatch.html#submit_form/3","title":"TestDispatch.submit_form/3","type":"function"},{"doc":"Works like submit_form/3 . The test_selector is used to find the right form and the entity is used to find and fill the inputs correctly.","ref":"TestDispatch.html#submit_form/4","title":"TestDispatch.submit_form/4","type":"function"},{"doc":"Works like submit_form/3 but instead of an entity or test_selector it uses the text of the button to match on the third argument. Examples iex&gt; submit_with_button ( conn , %{ answer_option : &quot;elixir&quot; } , &quot;Finish Quiz&quot; ) % Plug.Conn { params : %{ &quot;answer_option&quot; =&gt; &quot;elixir&quot; } }","ref":"TestDispatch.html#submit_with_button/3","title":"TestDispatch.submit_with_button/3","type":"function"},{"doc":"This library was built to test if forms and links have the expected results in controller tests when they would be submitted or clicked on. It can be used with or without the implementation of TestSelector .","ref":"testing-with-test-dispatch.html","title":"Testing with TestDispatch","type":"extras"},{"doc":"We will explain the workings with the following form. &lt;form action=&quot;admin/users/create&quot; method=&quot;post&quot;&gt; &lt;input name=&quot;_csrf_token&quot; type=&quot;hidden&quot; value=&quot;AHIqJmEUAxIvGy4HJ3oUGCMjChsLYBZ-SGgy7W1HElh3PKLsffgXXQO6&quot;&gt; &lt;label&gt;Name&lt;/label&gt; &lt;input id=&quot;user_name&quot; label=&quot;Name&quot; name=&quot;user[name]&quot; type=&quot;text&quot;&gt; &lt;label&gt;Email&lt;/label&gt; &lt;input id=&quot;user_email&quot; label=&quot;Email&quot; name=&quot;user[email]&quot; type=&quot;email&quot;&gt; &lt;label&gt;Description&lt;/label&gt; &lt;textarea id=&quot;user_description&quot; label=&quot;Description&quot; name=&quot;user[description]&quot; type=&quot;textarea&quot;&gt;&lt;/textarea&gt; &lt;select id=&quot;user_role&quot; name=&quot;user[role]&quot;&gt; &lt;option value=&quot;&quot;&gt;Select a role&lt;/option&gt; &lt;option value=&quot;admin&quot;&gt;Admin&lt;/option&gt; &lt;option value=&quot;moderator&quot;&gt;Moderator&lt;/option&gt; &lt;/select&gt; &lt;button type=&quot;submit&quot;&gt;Create new user&lt;/button&gt; &lt;/form&gt; This form is shown on /admin/users/new the entity for this form is user . To post the form as is we can use the following code: conn |&gt; get ( &quot;/admin/users/new&quot; ) |&gt; disptach_form_with ( :user ) |&gt; html_response ( 422 ) =~ &quot;can&#39;t be blank&quot; A request is made to the router here with the method POST to the action /admin/users/create and with the params %{&quot;user&quot; =&gt; %{&quot;name&quot; =&gt; &quot;&quot;, &quot;email&quot; =&gt; &quot;&quot;, &quot;description&quot; =&gt; &quot;&quot;, &quot;roles&quot; =&gt; &quot;&quot;}} The submit_form/3 will return a conn with the response of the controller. In this case it has returned an error because all fields are left blank. To update the fields while posting, a map can be given that matches the fields. params = %{ name : &quot;Marcel&quot; , email : &quot;marcel@example.com&quot; , description : &quot;Securing this place&quot; , role : &quot;moderator&quot; } conn |&gt; get ( &quot;/admin/users/new&quot; ) |&gt; disptach_form_with ( params , :user ) |&gt; redirected_to ( 302 ) == &quot;/admin/users/2&quot; Now that the params are given each key is matched to the keys in the form and updated with the value that is provided. If the keys do not match they won't be posted. ### TestSelector Some forms can be created that only have a submit button and cannot be found with an entity. In this we can use TestSelector to find the form and submit it. &lt;form action=&quot;admin/posts/1&quot; method=&quot;delete&quot; test-selector=&quot;posts-123-delete-post&quot;&gt; &lt;input name=&quot;_csrf_token&quot; type=&quot;hidden&quot; value=&quot;AHIqJmEUAxIvGy4HJ3oUGCMjChsLYBZ-SGgy7W1HElh3PKLsffgXXQO6&quot;&gt; &lt;button type=&quot;submit&quot;&gt;Remove&lt;/button&gt; &lt;/form&gt; This form can be submitted with conn |&gt; get ( &quot;/admin/posts&quot; ) |&gt; submit_form ( &quot;post-123-delete-post&quot; ) |&gt; html_response ( 200 ) =~ &quot;Post is deleted&quot; More documentation on how to use TestSelector can be found in TestSelectors wiki ## Testing Links Links can also be submitted and currently we can only do this by using TestSelector. For this click_link/3 can be used. For this example we can take a posts show page on /posts/1 &lt;div&gt; &lt;h1&gt;Post&lt;/h1&gt; &lt;a href=&quot;/posts/1&quot; data-method=&quot;delete&quot; test-selector=&quot;post-123-delete-post&quot;&gt; Remove &lt;/a&gt; &lt;table&gt; &lt;tr&gt; &lt;td&gt;This is perfect&lt;/td&gt; &lt;td&gt; &lt;a href=&quot;/posts/1/comments/1&quot; data-method=&quot;post&quot; test-value=&quot;1&quot; test-selector=&quot;post-123-upvote-comment&quot; &gt; Upvote Comment &lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;A better comment&lt;/td&gt; &lt;td&gt; &lt;a href=&quot;/posts/1/comments/2&quot; data-method=&quot;post&quot; test-value=&quot;1&quot; test-selector=&quot;post-123-upvote-comment&quot; &gt; Upvote Comment &lt;/td&gt; &lt;/tr&gt; &lt;/table&gt; &lt;/div&gt; We can now delete this post in the controller test by doing: conn |&gt; get ( &#39;/posts/1&#39; ) |&gt; click_link ( &quot;post-123-delete-post&quot; ) |&gt; html_response ( 200 ) =~ &quot;Post was deleted&quot; The click_link parses the page and tries to find post-123-delete-post it take the method by the data-method attribute. The url to click on is taken from the href . In this case a delete request is done to posts/1 . To take a specific element from a list test-values can be used as third argument of click_link/3 . conn |&gt; get ( &#39;/posts/1&#39; ) |&gt; click_link ( &quot;post-123-upvote-comment&quot; , &quot;1&quot; ) |&gt; html_response ( 200 ) =~ &quot;Upvoted comment 2&quot; As expected here a post request is done to /posts/1/comments/2 for the second comment. If there is no data-method set click_link/3 will do a get request by default. ## Clicking on links in mails During the tests emails might be sent that we want to integrate in our flow. For that there is receive_mail/2 . It expects the conn as the first argument and the found email will be added to the conn as the resp_body . Using the conn combined with the click_link/4 function you can simulate &quot;clicking&quot; on the link in an email. build_conn ( ) |&gt; get ( &quot;/posts/1&quot; ) |&gt; click_link ( &quot;post-123-send-as-mail&quot; ) |&gt; receive_mail ( ) |&gt; click_link ( &quot;post-123-show&quot; ) |&gt; html_response ( 200 ) TestDispatch expects the email to be send with the message {:delivered_email, %{} = email} where the mail should contain at least the to: , from: and subject: , html_body: fields. When the mail is not received it will raise an error. Specific emails can be targeted by adding the :subject , :to or :from to the second argument of receive mail in a map. receive_mail ( conn , %{ submit : &quot;This exact message&quot; , to : &quot;this_address@exmaple.com&quot; } )","ref":"testing-with-test-dispatch.html#testing-a-form","title":"Testing with TestDispatch - Testing a form","type":"extras"}]